<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | Navigation Manager - Navman Plugin for Geeklog                            |
// +---------------------------------------------------------------------------+
// | plugins/navman/functions.inc                                              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 dengen - taharaxp AT gmail DOT com                     |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett               -    twillett AT users DOT sourceforge DOT net  |
// | Blaine Lang               -    langmail AT sympatico DOT ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                -    tony AT tonybibbs DOT com                  |
// | Modified by:                                                              |
// | mystral-kk                -    geeklog AT mystral-kk DOT net              |
// | dengen                    -    taharaxp AT gmail DOT com                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.inc') !== false) {
    die('This file can not be used on its own.');
}

if (!defined('XHTML')) {
    define('XHTML', '');
}

/**
* Include language file
*/
$plugin_path = $_CONF['path'] . 'plugins/navman/';
$langfile = $plugin_path . 'language/' . $_CONF['language'] . '.php';

if (file_exists($langfile)) {
    require_once $langfile;
} else {
    require_once $plugin_path . 'language/english.php';
}

$_NAVM_CONF = array();

/**
* Include navman config file
*/
require_once $plugin_path . 'config.php';

/**
* Check and see if we need to load the plugin configuration
*/
require_once $_CONF['path_system'] . 'classes/config.class.php';
$plg_config = config::get_instance();
$temp = $plg_config->get_config('navman');
if (is_array($temp)) {
    $_NAVM_CONF = array_merge($_NAVM_CONF, $temp);
}

// テンプレートパスおよびCSSのURLを設定する
$_NAVM_CONF['path_layout'] = $_CONF['path_html'] . 'navman/templates';
$_NAVM_CONF['css_url'] = $_CONF['site_url'] . '/navman/templates';
if ($_NAVM_CONF['use_theme']) {
    if (is_dir($_CONF['path_layout'] . 'navman')) {
        $_NAVM_CONF['path_layout'] = $_CONF['path_layout'] . 'navman';
        $_NAVM_CONF['css_url'] = $_CONF['layout_url'] . '/navman';
    }
}

$_NAVM_CONF['current_url'] = COM_getCurrentURL();

if(!empty($topic)) {
    $_NAVM_CONF['topicsql'] = " AND (tid = '$topic' OR tid = 'all')";
} else {

    if(COM_onFrontpage()) {
//  if(NAVM_onFrontpage()) {

        $_NAVM_CONF['topicsql'] = " AND (tid = 'homeonly' OR tid = 'all')";
    } else {
        $_NAVM_CONF['topicsql'] = " AND (tid = 'all')";
    }
}

//$_NAVM_CONF['topicsql'] = '';

$_NAVM_CONF['permsql'] = COM_getPermSQL('AND');

$_NAVM_CONF['lang_id'] = COM_getLanguageId();

// opt_match = {
// 0 = 'part',
// 1 = 'all',
// 2 = 'preg',
//}
// render = {
// 0 = 'menu',
// 1 = 'breadcrumbs',
//}
// render_for = {
// 0 = 'header',
// 1 = 'footer',
// 2 = 'block',
//}

/**
* Check if we're on Geeklog's index page.
*
* See if we're on the main index page (first page, no topics selected).
*
* @return   bool    true = we're on the frontpage, false = we're not
*
*/
/*
function NAVM_onFrontpage()
{
    global $_CONF, $topic, $page, $newstories;

    // Note: We can't use $PHP_SELF here since the site may not be in the
    // DocumentRoot
    $onFrontpage = false;

    // on a Zeus webserver, prefer PATH_INFO over SCRIPT_NAME
    if( empty( $_SERVER['PATH_INFO'] ))
    {
        $scriptName = $_SERVER['SCRIPT_NAME'];
    }
    else
    {
        $scriptName = $_SERVER['PATH_INFO'];
    }

    preg_match( '/\/\/[^\/]*(.*)/', $_CONF['site_url'], $pathonly );
    if(( $scriptName == $pathonly[1] . '/index.php' ) &&

//          empty( $topic ) && ( $page == 1 ) && !$newstories )
            empty( $topic ) && !$newstories )
    {
        $onFrontpage = true;
    }

    return $onFrontpage;
}
*/

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+


/**
* Check to see if this Plugin uses comments
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_navman()
{
    return false;
}

/**
* This will put an option for navman in the command and control block on
* moderation.php
*
* @return   mixed   array(title, url, icon), or boolean false when not allowed
*
*/
function plugin_cclabel_navman()
{
    global $_CONF, $LANG_NAVM;

    if (SEC_hasRights('navman.admin')) {
        return array ($LANG_NAVM['display_name'],
                      $_CONF['site_admin_url'] . '/plugins/navman/index.php',
                      plugin_geticon_navman());
    }

    return false;
}

/**
* Returns the URL of the plugin's icon
*
* @return   string      URL of the icon
*
*/
function plugin_geticon_navman()
{
    global $_CONF;

    return $_CONF['site_url'] . '/navman/images/navman.gif';
}

/**
* returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify use it
*
* @return   mixed   array(title, url, num. items), or void when not allowed
*
*/
function plugin_getadminoption_navman()
{
    global $_CONF, $_TABLES, $LANG_NAVM;

    if (SEC_hasRights('navman.admin', 'OR')) {
        $pi_name   = $LANG_NAVM['display_name'];
        $admin_url = $_CONF['site_admin_url'] . '/plugins/navman/index.php';
        $num_items = DB_getItem($_TABLES['navmmenus'], 'COUNT(*)',
                                COM_getPermSql (''));

        return array($pi_name, $admin_url, $num_items);
    }
}

/**
* Called by the plugin Editor to display the current plugin code version
* This may be different than the version installed and registered currently.
* If newer then you may want to run the update
*
* @return   string  version number
*
*/
function plugin_chkVersion_navman()
{
    global $_NAVM_CONF;

    return $_NAVM_CONF['version'];
}

/**
* Upgrade the navman plugin
*
* @return   int     Number of message to display (true = generic success msg)
*
*/
function plugin_upgrade_navman()
{
    global $_CONF, $_TABLES, $_NAVM_CONF;

    // the plugin needs these function so complain when they don't exist
    if (!function_exists('COM_truncate') || !function_exists('MBYTE_strpos')) {
        return 3002;
    }

    $pi_version = DB_getItem($_TABLES['plugins'], 'pi_version', "(pi_name = 'navman')");

    // Update the version numbers
    DB_query("UPDATE {$_TABLES['plugins']} "
           . "SET pi_version = '{$_NAVM_CONF['version']}', pi_gl_version = '" . VERSION . "' "
           . "WHERE pi_name = 'navman'");

    return true;
}

/**
* Automatic uninstall function for plugins
*
* @return   array
*
* This code is automatically uninstalling the plugin.
* It passes an array to the core code function that removes
* tables, groups, features and php blocks from the tables.
* Additionally, this code can perform special actions that cannot be
* foreseen by the core code (interactions with other plugins for example)
*
*/

function plugin_autouninstall_navman()
{
    $out = array(
        // give the name of the tables, without $_TABLES[]
        'tables' => array('navmmenus', 'navmmenuitems'),

        // give the full name of the group, as in the db
        'groups' => array('Navman Admin'),

        // give the full name of the feature, as in the db
        'features' => array('navman.admin'),
    );
    return $out;
}


function plugin_getListField_navman($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $LANG25, $LANG_ACCESS;

    $retval = '';
    $access = SEC_hasAccess($A['owner_id'],     $A['group_id'],
                            $A['perm_owner'],   $A['perm_group'],
                            $A['perm_members'], $A['perm_anon']);
    if ($access > 0) {
        switch ($fieldname) {
            case 'edit':
                if ($access == 3) { // User is in Root group
                    $retval = "<a href=\"{$_CONF['site_admin_url']}/plugins/navman/index.php"
                            . "?mode=edit&amp;uid={$A['uid']}\">{$icon_arr['edit']}</a>";
                }
                break;
            default:
                $retval = $fieldvalue;
                break;
        }
    } else {
        $retval = false;
    }

    return $retval;
}


/**
* Get header code for inclusion
*
* @return   string
*
*/
function plugin_getheadercode_navman ()
{
    global $_CONF, $_TABLES, $_NAVM_CONF;

    $retval = '';
    $result = DB_query(
        "SELECT DISTINCT template_name FROM {$_TABLES['navmmenus']} "
      . "WHERE template_name <> '' AND is_enabled = 1 "
      . $_NAVM_CONF['permsql']);
    while ($A = DB_fetchArray($result)) {
        $path_layout = $_NAVM_CONF['path_layout'] . '/' . $A['template_name'] . '/navman.css';
        if (!file_exists($path_layout)) continue;
        $retval .= '<link rel="stylesheet" type="text/css" href="'
                 . $_NAVM_CONF['css_url'] . '/' . $A['template_name'] . '/navman.css' . '">' . LB;
    }
    if (!empty($retval)) {
        return '<!-- Include CSS for Navigation Manager -->' . LB . $retval;
    }
    return $retval;
}


/**
* Set template variables
*
* @param    string  $templatename   name of template, e.g. 'header'
* @param    ref     $template       reference of actual template
* @return   void
*
*/
function plugin_templatesetvars_navman ($templatename, &$template)
{
    global $_NAVM_CONF, $_TABLES;

    // アンインストール直後に実行されてしまうのを防ぐため
    if (!DB_checkTableExists('navmmenus')) return;

    if ($templatename == 'header') {
        foreach ($_NAVM_CONF['templatevar'] as $templatevar) {
            $template->set_var($templatevar, ''); // 初期化
        }
        $result = DB_query(
            "SELECT nid, var_name, gid, class_name, template_name, pattern, opt_match, render "
          . "FROM {$_TABLES['navmmenus']} "
          . "WHERE render_for = 0 AND is_enabled = 1 "
          . $_NAVM_CONF['permsql']);
        while ($A = DB_fetchArray($result)) {
            $tvar = $template->get_var($_NAVM_CONF['templatevar'][$A['var_name']]);
            if (!empty($tvar)) continue;
            if ($A['render'] == 0) {
                $template->set_var(
                    $_NAVM_CONF['templatevar'][$A['var_name']],
                    NAVM_rendarMenu($A));
            } else if ($_NAVM_CONF['enable_breadcrumbs']) {
                $template->set_var(
                    $_NAVM_CONF['templatevar'][$A['var_name']],
                    NAVM_renderBreadcrumbs($A));
            }
        }
    }

    if ($templatename == 'footer') {
        foreach ($_NAVM_CONF['templatevar'] as $templatevar) {
            $template->set_var($templatevar, ''); // 初期化
        }
        $result = DB_query(
            "SELECT nid, var_name, gid, class_name, template_name, pattern, opt_match, render "
          . "FROM {$_TABLES['navmmenus']} "
          . "WHERE render_for = 1 AND is_enabled = 1 "
          . $_NAVM_CONF['permsql']);
        while ($A = DB_fetchArray($result)) {
            $tvar = $template->get_var($_NAVM_CONF['templatevar'][$A['var_name']]);
            if (!empty($tvar)) continue;
            if ($A['render'] == 0) {
                $template->set_var(
                    $_NAVM_CONF['templatevar'][$A['var_name']],
                    NAVM_rendarMenu($A));
            } else if ($_NAVM_CONF['enable_breadcrumbs']) {
                $template->set_var(
                    $_NAVM_CONF['templatevar'][$A['var_name']],
                    NAVM_renderBreadcrumbs($A));
            }
        }
    }

}


/**
* Add Menuitems of the plugins
*/
function NAVM_addPluginsMenuitems()
{
    global $_CONF, $_PLUGINS, $_TABLES, $_USER, $_NAVM_plugin_label_var;

    $SQLS = array();
    $num = DB_getItem($_TABLES['navmmenuitems'], "MAX(menuorder)") + 10;
    $menuitems = array();
    $group_id = DB_getItem($_TABLES['groups'], 'grp_id', "grp_name = 'Navman Admin'");
    foreach ($_PLUGINS as $pi_name) {
        if ($pi_name == 'staticpages') continue;
        if (DB_count($_TABLES['navmmenuitems'], "mid", $pi_name) == 1) continue;
        $function = 'plugin_getmenuitems_' . $pi_name;
        if (!function_exists($function)) continue;
        $menuitems = $function();
        if ((is_array($menuitems)) && (sizeof($menuitems) > 0)) {
            $mid = $pi_name;
            $url = addslashes(current($menuitems));
            $url = str_replace($_CONF['site_url'], '[site_url]', $url);
            $label = addslashes(key($menuitems));
            $label_var = (!empty($_NAVM_plugin_label_var[$pi_name])) ? $_NAVM_plugin_label_var[$pi_name] : '';
            $label_var = addslashes($label_var);
            $SQLS[] = "INSERT INTO " . $_TABLES['navmmenuitems']
                    . " (mid, gid, is_enabled, type, label, label_var, url, menuorder, pattern, opt_match, owner_id, group_id) "
                    . "VALUES ('$mid', 0, 1, 'plugin', '$label', '$label_var', '$url', $num, '@(?<!plugins)/$mid/index\\\\\\\\.php@', 2, {$_USER['uid']}, '$group_id')";
            $num += 1;
        }
    }

    foreach ($SQLS as $sql) {
        DB_query($sql, 1);
        if (DB_error()) return false;
    }
}


function NAVM_replaceLabel($label)
{
    preg_match('/(.+)\[(.+)\]/', $label, $m);
    if (($m[1] != '') && ($m[2] != '')) {
        $m[2] = str_replace("'", "", $m[2]);
        $m[2] = str_replace('"', "", $m[2]);
        $label = $GLOBALS[ $m[1] ][ $m[2] ];
    } else {
        $label = $GLOBALS[$label];
    }

    return $label;
}

function NAVM_replaceUrl($url)
{
    global $_CONF;

    $url = str_replace('[site_url]',       $_CONF['site_url'],       $url);
    $url = str_replace('[site_admin_url]', $_CONF['site_admin_url'], $url);

    return $url;
}

/**
*
*/
function NAVM_getParentArray($pmid="", $parray = array())
{
    global $_TABLES;

    $result = DB_query("SELECT * FROM {$_TABLES['navmmenuitems']} WHERE mid = '$pmid'");
    if (DB_numRows($result) == 0) return $parray;

    $A = DB_fetchArray($result);
    if (!empty($A['pmid'])) {
        $parray = NAVM_getParentArray($A['pmid'], $parray);
    }
    if ($A['is_enabled'] == 1) {
        array_push($parray, $A);
    }

    return $parray;
}


function NAVM_rendarMenu(&$A)
{
    global $_CONF, $_TABLES, $_NAVM_CONF;

    if (!is_array($A)) {
        $result = DB_query(
            "SELECT nid, gid, class_name, template_name, pattern, opt_match "
          . "FROM {$_TABLES['navmmenus']} WHERE nid = '$A'");
        $A = DB_fetchArray($result);
    }
    if (empty($A['nid'])) return '';

    $_NAVM_CONF['path_template'] = $_NAVM_CONF['path_layout']
          . (!empty($A['template_name']) ? '/' . $A['template_name'] : 'default');
    if (!is_dir($_NAVM_CONF['path_template'])) return '';

    $pattern = stripslashes($A['pattern']);
    $selected = true;
    if (!empty($pattern)) {
        switch ($A['opt_match']) {
            case 0:
                $pattern = NAVM_replaceUrl($pattern);
                $selected = (strpos($_NAVM_CONF['current_url'], $pattern) !== false);
                break;

            case 1:
                $pattern = NAVM_replaceUrl($pattern);
                $selected = (strcmp($_NAVM_CONF['current_url'], $pattern) == 0);
                break;

            case 2:
                $selected = (preg_match($pattern, $_NAVM_CONF['current_url']) != 0);
                break;
        }
    }
    if (!$selected) return '';

    $T = new Template($_NAVM_CONF['path_template']);
    $T->set_file(array(
        'navimenu'        => 'navimenu.thtml',
        'menuitem_custom' => 'menuitem.thtml',
        'menuitem_drop'   => 'menuitem_drop.thtml',
    ));
    $T->set_var('xhtml', XHTML);
    $T->set_var('nid', $A['nid']);
    $T->set_var('navi_class_property',
                (empty($A['class_name'])) ? '' : (' class="' . stripslashes($A['class_name']) . '"'));
    $T->set_var('menu_elements', NAVM_renderMenu_sub_recursive($T, $A['gid'], 1));
    $T->parse('navigation', 'navimenu');
    return $T->finish($T->get_var('navigation'));
}


function NAVM_renderMenu_sub_recursive(&$T, $gid, $level, $pmid='')
{
    global $_CONF, $_TABLES, $_NAVM_CONF;

    $T->set_var('level', $level);
    $T->set_var('class_level', 'level' . $level);
    $result = DB_query(
       "SELECT * FROM {$_TABLES['navmmenuitems']} "
     . "WHERE is_enabled = 1 AND gid = '$gid' "
     . "AND pmid = '$pmid'"
     . $_NAVM_CONF['topicsql'] . $_NAVM_CONF['permsql']
     . " ORDER BY menuorder ASC");
    while ($A = DB_fetchArray($result)) {

        $result2 = DB_query(
            "SELECT * FROM {$_TABLES['navmmenuitems']} "
          . "WHERE mid = '" . $A['mid'] . '_' . $_NAVM_CONF['lang_id'] . "'");
        if (DB_numRows($result2) == 1) {
            // overwrite with data for language-specific menuitem
            $A = DB_fetchArray($result2);
        }

        $access = SEC_hasAccess($A['owner_id'],    $A['group_id'],
                                $A['perm_owner'],  $A['perm_group'],
                                $A['perm_members'],$A['perm_anon']);
        if (!($access > 0)) continue;

        // PHPフィルターの適用
        if (!empty($A['php_function'])) {
            $str = strtr(stripslashes($A['php_function']), ',', ' ');
            $farr = explode(" ", $str);
            foreach ($farr as $f) {
                $function = 'phpfilter_' . $f;
                if (function_exists($function)) $function($A);
            }
        }
        if (!empty($A['label_var'])) {
            $label1 = stripslashes($A['label_var']);
            $label2 = NAVM_replaceLabel($label1);
            $label = (!empty($label2)) ? $label2 : '(' . $A['mid'] . ')';
        } else {
            if (!empty($A['label'])) {
                $label = stripslashes($A['label']);
            } else {
                $label = '(' . $A['mid'] . ')';
            }
        }

        $pattern = stripslashes($A['pattern']);
        $selected = false;
        if (!empty($pattern)) {
            switch ($A['opt_match']) {
                case 0:
                    $pattern = NAVM_replaceUrl($pattern);
                    $selected = (strpos($_NAVM_CONF['current_url'], $pattern) !== false);
                    break;

                case 1:
                    $pattern = NAVM_replaceUrl($pattern);
                    $selected = (strcmp($_NAVM_CONF['current_url'], $pattern) == 0);
                    break;

                case 2:
                    $selected = (preg_match($pattern, $_NAVM_CONF['current_url']) != 0);
                    break;
            }
        }

        $class_name = trim(stripslashes($A['class_name']));
        $class_property = (empty($class_name)) ? '' : (' class="' . $class_name . '"');

        $T->set_var('menuitem_url',   NAVM_replaceUrl($A['url']));
        $T->set_var('menuitem_text',  $label);
        $T->set_var('menuitem_id',    $_NAVM_CONF['prefix_id'] . stripslashes($A['mid']));
        $T->set_var('menuitem_class', $class_name);
        $T->set_var('class_property', $class_property);
        $T->set_var('menuitem_icon_url', NAVM_replaceUrl($A['icon_url']));
        $T->set_var('selected',       ($selected) ? 'selected' : '');

        $pmidcount = DB_getItem($_TABLES['navmmenuitems'], 'COUNT(*)',
                        "pmid = '{$A['mid']}' AND is_enabled = 1 "
                        . $_NAVM_CONF['topicsql'] . $_NAVM_CONF['permsql']);
        if ($pmidcount>0) {
            $level++;
            $T2 = new Template($_NAVM_CONF['path_template']);
            $T2->set_file(array(
                'menuitem_custom' => 'menuitem.thtml',
                'menuitem_drop'   => 'menuitem_drop.thtml',
            ));
            $T2->set_var('xhtml', XHTML);
            $T->set_var('submenu_elements',
                NAVM_renderMenu_sub_recursive($T2, $gid, $level, $A['mid']));
            $T->parse('menu_elements', 'menuitem_drop', true);
        } else {
            $T->parse('menu_elements', 'menuitem_custom', true);
        }
    }
    return $T->finish($T->get_var('menu_elements'));
}


function NAVM_renderBreadcrumbs(&$NM)
{
    global $_CONF, $_TABLES, $_NAVM_CONF, $LANG_NAVM;

    if (!is_array($NM)) {
        $result = DB_query(
            "SELECT nid, gid, class_name, template_name "
          . "FROM {$_TABLES['navmmenus']} WHERE nid = '$NM'");
        $NM = DB_fetchArray($result);
    }
    if (empty($NM['nid'])) return '';

    $path_template = $_NAVM_CONF['path_layout']
          . (!empty($NM['template_name']) ? '/' . stripslashes($NM['template_name']) : 'default');
    if (!is_dir($path_template)) return '';

    $B = array();
    $result = DB_query(
        "SELECT * FROM {$_TABLES['navmmenuitems']} "
      . "WHERE is_enabled = 1 AND gid = '{$NM['gid']}'"
      . $_NAVM_CONF['topicsql']
      . " ORDER BY menuorder ASC");
    // カレントURLとマッチするメニューアイテムを配列$Bに抽出する。
    while ($A = DB_fetchArray($result)) {

        $result2 = DB_query(
            "SELECT * FROM {$_TABLES['navmmenuitems']} "
          . "WHERE mid = '" . $A['mid'] . '_' . $_NAVM_CONF['lang_id'] . "'");
        if (DB_numRows($result2) == 1) {
            // overwrite with data for language-specific menuitem
            $A = DB_fetchArray($result2);
        }

        $access = SEC_hasAccess($A['owner_id'],    $A['group_id'],
                                $A['perm_owner'],  $A['perm_group'],
                                $A['perm_members'],$A['perm_anon']);
        if (!($access > 0)) continue;

        $pattern = stripslashes($A['pattern']);
        $match = false;
        if (!empty($pattern)) {
            switch ($A['opt_match']) {
                case 0:
                    $pattern = NAVM_replaceUrl($pattern);
                    $match = (strpos($_NAVM_CONF['current_url'], $pattern) !== false);
                    break;

                case 1:
                    $pattern = NAVM_replaceUrl($pattern);
                    $match = (strcmp($_NAVM_CONF['current_url'], $pattern) == 0);
                    break;

                case 2:
                    $match = (preg_match($pattern, $_NAVM_CONF['current_url']) != 0);
                    break;
            }
        }
        if (!$match) continue;

        $B[] = $A;
        break;
    }

    $C = NAVM_getParentArray($B[0]['mid']);
    $i = count($C);

    if (($i == 0) && (! $_NAVM_CONF['show_bc_inhome'])) return '';

    $T2 = new Template($path_template);
    $T2->set_file(array(
        'breadcrumb'        => 'breadcrumb.thtml',
        'breadcrumb_nolink' => 'breadcrumb_nolink.thtml',
        'breadcrumbs'       => 'breadcrumbs.thtml'
    ));
    $T2->set_var('nid', $NM['nid']);
    $T2->set_var('breadcrumbs_class', stripslashes($NM['class_name']));

    $T2->set_var('menuitem_class', 'first_bc');
    $T2->set_var('menuitem_text', $LANG_NAVM['label_home']);
    if ($i==0) {
        $T2->set_var('bc_order', 'current');
        if (! $_NAVM_CONF['current_with_link']) {
            $T2->parse('breadcrumbs_list', 'breadcrumb_nolink', true);
        } else {
            $T2->set_var('menuitem_url', $_CONF['site_url']);
            $T2->parse('breadcrumbs_list', 'breadcrumb', true);
        }
    } else {
        $T2->set_var('bc_order', '');
        $T2->set_var('menuitem_url', $_CONF['site_url']);
        $T2->parse('breadcrumbs_list', 'breadcrumb', true);
    }

    foreach ($C as $bc) {

        $i--;
        $bc['bc'] = true;

        // PHPフィルターの適用
        $str = strtr(stripslashes($bc['php_function']), ',', ' ');
        $farr = explode(" ", $str);
        foreach ($farr as $f) {
            $function = 'phpfilter_' . $f;
            if (function_exists($function)) $function($bc);
        }

        $url        = NAVM_replaceUrl($bc['url']);
        $class_name = stripslashes($bc['class_name']);
        $id_name    = stripslashes($bc['mid']);

        if (!empty($bc['label_var'])) {
            $label = stripslashes($bc['label_var']);
            $label = NAVM_replaceLabel($label);
        } else {
            if (!empty($bc['label'])) {
                $label = stripslashes($bc['label']);
            } else {
                $label = 'noname';
            }
        }

        $T2->set_var('menuitem_class', $class_name);
        $T2->set_var('menuitem_text', $label);
        if ($i==0) {
            $T2->set_var('bc_order', 'current');
            if (! $_NAVM_CONF['current_with_link']) {
                $T2->parse('breadcrumbs_list', 'breadcrumb_nolink', true);
            } else {
                $T2->set_var('menuitem_url',   $url);
                $T2->parse('breadcrumbs_list', 'breadcrumb', true);
            }
        } else {
            $T2->set_var('bc_order', '');
            $T2->set_var('menuitem_url',   $url);
            $T2->parse('breadcrumbs_list', 'breadcrumb', true);
        }
    }
    $T2->parse('bcs', 'breadcrumbs');

    return $T2->finish($T2->get_var('bcs'));
}


/**
* Implements the [navi:] autotag.
*
*/
function plugin_autotags_navman($op, $content = '', $autotag = '')
{
    global $_CONF, $_NAVM_CONF, $_TABLES;

    if ($op == 'tagname') {
        return $_NAVM_CONF['tagname'];
    } else if ($op == 'parse') {
        if (!DB_checkTableExists('navmmenus')) return '';
        $nid = COM_applyFilter($autotag['parm1']);
        $sql = "SELECT nid,render FROM {$_TABLES['navmmenus']} "
             . "WHERE nid = '$nid' AND is_enabled = 1 "
             . $_NAVM_CONF['permsql'];

        $result = DB_query($sql);
        $A = DB_fetchArray($result);
        $menu = '';
        if (!empty($A['nid'])) {
            if ($A['render'] == 1) {
                if ($_NAVM_CONF['enable_breadcrumbs']) {
                    $menu = NAVM_renderBreadcrumbs($A['nid']);
                }
            } else {
                $menu = NAVM_rendarMenu($A['nid']);
            }
        }
        $content = str_replace($autotag['tagstr'], $menu, $content);
        return $content;
    }
}


function NAVM_makeFuncstr()
{
    global $_TABLES, $_NAVM_CONF;

    $retval = '';
    if (!DB_checkTableExists('navmmenus')) return '';
    $result = DB_query(
        "SELECT nid, is_enabled, owner_id, group_id, perm_owner, perm_group, perm_members, perm_anon, render "
      . "FROM {$_TABLES['navmmenus']} WHERE render_for = 2");
    while ($A = DB_fetchArray($result)) {

        $access = SEC_hasAccess($A['owner_id'],    $A['group_id'],
                                $A['perm_owner'],  $A['perm_group'],
                                $A['perm_members'],$A['perm_anon']);

        $nid = $A['nid']; // 必要
        $func = '';
        if (($access > 0) && ($A['is_enabled'] == 1)) {
            if ($A['render'] == 0) {
                $func = NAVM_rendarMenu($nid);
            } else if ($_NAVM_CONF['enable_breadcrumbs']) {
                $func = NAVM_renderBreadcrumbs($nid);
            }
        }

        if (!function_exists('phpblock_' . $A['nid'])) {
            $retval .= "function phpblock_" . $A['nid'] . "(){return '" . $func . "';}";
        }
    }
    return $retval;
}

// PHPブロック関数を動的に定義する。
eval(NAVM_makeFuncstr());

/**
* Include filters.php
*/
require_once $plugin_path . 'filters.php';

?>